package cn.estsh.i3plus.ext.mes.pcn.apiservice.serviceimpl.busi.step.jx;

import cn.estsh.i3plus.ext.mes.pcn.api.busi.jx.IJxProdBindRecordExtService;
import cn.estsh.i3plus.mes.pcn.serviceimpl.base.BaseStepService;
import cn.estsh.i3plus.pojo.mes.model.StationRequestBean;
import cn.estsh.i3plus.pojo.mes.model.StationResultBean;
import cn.estsh.i3plus.pojo.mes.model.StepResult;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

/**
 * @Description : 嘉兴下线箱包二检工步
 * @Reference :
 * @Author : wangjie
 * @CreateDate : 2019-07-11
 * @Modify:
 **/
@Slf4j
@Service("jxSnLineOffCheckPartKeyStepService")
public class JxSnLineOffCheckPartKeyStepService extends BaseStepService {

    @Autowired
    private IJxProdBindRecordExtService prodBindRecordExtService;

    @Override
    public StepResult guide(StationRequestBean reqBean) {
        return execSuccessCompleteAndSendGuideReturn(reqBean, new StationResultBean(), String.format("当前产品[%s]已被标记为出货检验还线品,请扫描关键件进行复检!", reqBean.getProductSn()));
    }

    @Override
    public StepResult execute(StationRequestBean reqBean) {

        log.info("工厂{}生产线{}工位{}: --- STEP EXECUTE --- JxSnLineOffCheckPartKeyStepService --- START --- ", reqBean.getOrganizeCode(), reqBean.getWorkCenterCode(), reqBean.getWorkCellCode());

        StationResultBean resultBean = new StationResultBean();

        if (StringUtils.isEmpty(reqBean.getScanInfo())) execSendGuideAndThrowEx(reqBean, resultBean, String.format("当前产品[%s]已被标记为出货检验还线品,请扫描关键件进行复检!", reqBean.getProductSn()));

        String kpSn = reqBean.getScanInfo();

        reqBean.setScanInfo(null);

        Boolean result = prodBindRecordExtService.getProdBindRecordIsExist(reqBean.getOrganizeCode(), reqBean.getWorkOrderNo(), reqBean.getSerialNumber(), reqBean.getWorkCenterCode(), reqBean.getWorkCellCode(), kpSn);

        log.info("工厂{}生产线{}工位{}: --- STEP EXECUTE --- JxSnLineOffCheckPartKeyStepService --- SUCCESS ---", reqBean.getOrganizeCode(), reqBean.getWorkCenterCode(), reqBean.getWorkCellCode());

        if (!result) return execNonCompleteAndSendMsgReturn(reqBean, resultBean, String.format("复检失败!关键件条码[%s]复检不匹配当前出货检验还线品[%s]!", kpSn, reqBean.getProductSn()));

        return execSuccessCompleteAndSendMsgReturn(reqBean, resultBean, String.format("复检成功!关键件条码[%s]复检已匹配当前出货检验还线品[%s]!", kpSn, reqBean.getProductSn()));
    }

}
